osg::Object Class Referenceabstract

`#include <Object>`

Inheritance diagram for osg::Object:

## Public Types

enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

Base class/standard interface for objects which require IO support, cloning and reference counting. Based on GOF Composite, Prototype and Template Method patterns.

## Member Enumeration Documentation

## DataVariance

enum osg::Object::DataVariance

Enumerator
DYNAMIC |
STATIC |
UNSPECIFIED |

## Constructor & Destructor Documentation

## Object() [1/3]

osg::Object::Object | ( |  | ) |

inline

Construct an object. Note Object is a pure virtual base class and therefore cannot be constructed on its own, only derived classes which override the clone and className methods are concrete classes and can be constructed.

References _dataVariance, _userDataContainer, osg::Referenced::Referenced(), and UNSPECIFIED.

Referenced by osg::UserDataContainer::addUserObject(), osgPresentation::AnimationMaterial::AnimationMaterial(), osgPresentation::AnimationMaterialCallback::AnimationMaterialCallback(), osg::AnimationPath::AnimationPath(), osgWidget::BrowserManager::BrowserManager(), osg::BufferData::BufferData(), osg::BufferData::BufferData(), osg::Callback::Callback(), osg::StateSet::Callback::Callback(), osgAnimation::Action::Callback::Callback(), osg::GraphicsContext::clone(), osg::Node::clone(), clone(), osg::RefMatrixd::clone(), osg::RefMatrixf::clone(), osg::Shape::clone(), osg::StateAttribute::clone(), osg::StateSet::clone(), osgAnimation::TemplateChannel< DoubleStepSampler >::clone(), osg::GraphicsContext::cloneType(), osg::Node::cloneType(), cloneType(), osg::RefMatrixd::cloneType(), osg::RefMatrixf::cloneType(), osg::Shape::cloneType(), osg::StateAttribute::cloneType(), osg::StateSet::cloneType(), osgAnimation::TemplateChannel< DoubleStepSampler >::cloneType(), osg::Drawable::ComputeBoundingBoxCallback::ComputeBoundingBoxCallback(), osg::Node::ComputeBoundingSphereCallback::ComputeBoundingSphereCallback(), osg::ConvexPlanarOccluder::ConvexPlanarOccluder(), osg::ConvexPlanarOccluder::ConvexPlanarOccluder(), osgParticle::Counter::Counter(), osgParticle::Counter::Counter(), osg::Drawable::CreateVertexArrayStateCallback::CreateVertexArrayStateCallback(), osgManipulator::DraggerCallback::DraggerCallback(), osgManipulator::DraggerCallback::DraggerCallback(), osg::Drawable::DrawCallback::DrawCallback(), osg::DummyObject::DummyObject(), osg::EllipsoidModel::EllipsoidModel(), osgGA::EventHandler::EventHandler(), osg::UserDataContainer::getUserObject(), osg::UserDataContainer::getUserObject(), osg::UserDataContainer::getUserObject(), osg::UserDataContainer::getUserObject(), getUserValue(), osg::ValueMap::getValueOfType(), osg::ValueMap::getValueOfType(), osg::ValueStack::getValueOfType(), osg::ValueStack::getValueOfType(), osgGA::GUIEventHandler::GUIEventHandler(), osgPresentation::HomePosition::HomePosition(), osgDB::ImageProcessor::ImageProcessor(), osgDB::ImageProcessor::ImageProcessor(), osgViewer::InteractiveImageHandler::InteractiveImageHandler(), osgParticle::Interpolator::Interpolator(), osgParticle::Interpolator::Interpolator(), osg::AudioStream::isSameKindAs(), osg::BufferData::isSameKindAs(), osg::BufferObject::isSameKindAs(), osg::GraphicsContext::isSameKindAs(), osg::Node::isSameKindAs(), isSameKindAs(), osg::RefMatrixd::isSameKindAs(), osg::RefMatrixf::isSameKindAs(), osg::Shape::isSameKindAs(), osg::StateAttribute::isSameKindAs(), osg::StateSet::isSameKindAs(), osg::UserDataContainer::isSameKindAs(), osgAnimation::Channel::isSameKindAs(), osgViewer::GraphicsWindow::isSameKindAs(), osgViewer::GraphicsWindowEmbedded::isSameKindAs(), osgViewer::GraphicsWindowWin32::isSameKindAs(), osgViewer::GraphicsWindowX11::isSameKindAs(), osgViewer::PixelBufferWin32::isSameKindAs(), osgViewer::PixelBufferX11::isSameKindAs(), osgUI::Item::Item(), osgPresentation::JumpData::JumpData(), osgPresentation::KeyPosition::KeyPosition(), osgSim::LightPointSystem::LightPointSystem(), osgVolume::Locator::Locator(), osgVolume::Locator::LocatorCallback::LocatorCallback(), osgDB::MapIteratorObject::MapIteratorObject(), osgSim::ShapeAttributeList::META_Object(), osg::BufferData::ModifiedCallback::ModifiedCallback(), osgAnimation::MorphTransform::MorphTransform(), Object(), osgSim::ObjectRecordData::ObjectRecordData(), osgParticle::Operator::Operator(), osgParticle::Operator::Operator(), osgParticle::Placer::Placer(), osgParticle::Placer::Placer(), osgPresentation::PropertyManager::PropertyManager(), osg::ValueStack::push(), osgDB::ReaderWriter::ReaderWriter(), osgDB::ReaderWriter::ReaderWriter(), osg::RefMatrixd::RefMatrixd(), osg::RefMatrixd::RefMatrixd(), osg::RefMatrixd::RefMatrixd(), osg::RefMatrixd::RefMatrixd(), osg::RefMatrixd::RefMatrixd(), osg::RefMatrixd::RefMatrixd(), osg::RefMatrixf::RefMatrixf(), osg::RefMatrixf::RefMatrixf(), osg::RefMatrixf::RefMatrixf(), osg::RefMatrixf::RefMatrixf(), osg::RefMatrixf::RefMatrixf(), osg::RefMatrixf::RefMatrixf(), osgAnimation::RigTransform::RigTransform(), osg::Script::Script(), osgSim::Sector::Sector(), osg::UserDataContainer::setUserObject(), setUserValue(), osg::Shape::Shape(), osgSim::ShapeAttributeList::ShapeAttributeList(), osgParticle::Shooter::Shooter(), osgParticle::Shooter::Shooter(), osgAnimation::StackedTransformElement::StackedTransformElement(), osg::StateAttribute::StateAttribute(), osgUI::Tab::Tab(), osg::TessellationHints::TessellationHints(), osgGA::GUIEventAdapter::TouchData::TouchData(), osgGA::GUIEventAdapter::TouchData::TouchData(), osgAnimation::UpdateFloatUniform::UpdateFloatUniform(), osgAnimation::UpdateMatrixfUniform::UpdateMatrixfUniform(), osgAnimation::UpdateMorphGeometry::UpdateMorphGeometry(), osgAnimation::UpdateRigGeometry::UpdateRigGeometry(), osgAnimation::UpdateVec2fUniform::UpdateVec2fUniform(), osgAnimation::UpdateVec3fUniform::UpdateVec3fUniform(), osgAnimation::UpdateVec4fUniform::UpdateVec4fUniform(), osg::ValueObject::ValueObject(), osg::ValueObject::ValueObject(), osg::ValueObject::ValueObject(), osgAnimation::VertexInfluenceMap::VertexInfluenceMap(), and osgViewer::ViewConfig::ViewConfig().

## Object() [2/3]

osg::Object::Object | ( | bool | threadSafeRefUnref | ) |

inline explicit

References _dataVariance, _userDataContainer, osg::Referenced::Referenced(), and UNSPECIFIED.

## Object() [3/3]

osg::Object::Object | ( | const Object & | ,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

Copy constructor, optional CopyOp object can be used to control shallow vs deep copying of dynamic data.

References Object(), and osg::CopyOp::SHALLOW_COPY.

## ~Object()

virtual osg::Object::~Object | ( |  | ) |

protected virtual

Object destructor. Note, is protected so that Objects cannot be deleted other than by being dereferenced and the reference count being zero (see osg::Referenced), preventing the deletion of nodes which are still in use. This also means that Nodes cannot be created on stack i.e Node node will not compile, forcing all nodes to be created on the heap i.e Node* node = new Node().

## Member Function Documentation

## asCallback() [1/2]

virtual Callback * osg::Object::asCallback | ( |  | ) |

inline virtual

Convert 'this' into a Callback pointer if Object is a Callback, otherwise return 0. Equivalent to dynamic_cast<Callback*>(this).

Reimplemented in osg::Callback, osgAnimation::AnimationUpdateCallback< T >, osgAnimation::AnimationUpdateCallback< osg::NodeCallback >, osgAnimation::AnimationUpdateCallback< osg::StateAttributeCallback >, and osgAnimation::AnimationUpdateCallback< osg::UniformCallback >.

## asCallback() [2/2]

virtual const Callback * osg::Object::asCallback | ( |  | ) | const

inline virtual

convert 'const this' into a const Callback pointer if Object is a Callback, otherwise return 0. Equivalent to dynamic_cast<const Callback*>(this).

Reimplemented in osg::Callback, and osgAnimation::AnimationUpdateCallback< T >.

## asCallbackObject() [1/2]

virtual CallbackObject * osg::Object::asCallbackObject | ( |  | ) |

inline virtual

Convert 'this' into a CallbackObject pointer if Object is a CallbackObject, otherwise return 0. Equivalent to dynamic_cast<CallbackObject*>(this).

Reimplemented in osg::Callback, osg::CallbackObject, osgAnimation::AnimationUpdateCallback< T >, osgAnimation::AnimationUpdateCallback< osg::NodeCallback >, osgAnimation::AnimationUpdateCallback< osg::StateAttributeCallback >, and osgAnimation::AnimationUpdateCallback< osg::UniformCallback >.

Referenced by osg::getCallbackObject(), osg::getCallbackObject(), and osg::runNamedCallbackObjects().

## asCallbackObject() [2/2]

virtual const CallbackObject * osg::Object::asCallbackObject | ( |  | ) | const

inline virtual

convert 'const this' into a const CallbackObject pointer if Object is a CallbackObject, otherwise return 0. Equivalent to dynamic_cast<const CallbackObject*>(this).

Reimplemented in osg::Callback, osg::CallbackObject, and osgAnimation::AnimationUpdateCallback< T >.

## asCamera() [1/2]

virtual Camera * osg::Object::asCamera | ( |  | ) |

inline virtual

Convert 'this' into a Camera pointer if Node is a Camera, otherwise return 0. Equivalent to dynamic_cast<Camera*>(this).

Reimplemented in osg::Camera.

## asCamera() [2/2]

virtual const Camera * osg::Object::asCamera | ( |  | ) | const

inline virtual

convert 'const this' into a const Camera pointer if Node is a Camera, otherwise return 0. Equivalent to dynamic_cast<const Camera*>(this).

Reimplemented in osg::Camera.

## asDrawable() [1/2]

virtual Drawable * osg::Object::asDrawable | ( |  | ) |

inline virtual

Convert 'this' into a Drawable pointer if Object is a Drawable, otherwise return 0. Equivalent to dynamic_cast<Drawable*>(this).

Reimplemented in osg::Drawable, and osg::Node.

## asDrawable() [2/2]

virtual const Drawable * osg::Object::asDrawable | ( |  | ) | const

inline virtual

convert 'const this' into a const Drawable pointer if Object is a Drawable, otherwise return 0. Equivalent to dynamic_cast<const Drawable*>(this).

Reimplemented in osg::Drawable, and osg::Node.

## asImage() [1/2]

virtual Image * osg::Object::asImage | ( |  | ) |

inline virtual

Convert 'this' into a Image pointer if Object is a Image, otherwise return 0. Equivalent to dynamic_cast<Image*>(this).

Reimplemented in osg::BufferData, and osg::Image.

## asImage() [2/2]

virtual const Image * osg::Object::asImage | ( |  | ) | const

inline virtual

Convert 'this' into a Image pointer if Object is a Image, otherwise return 0. Equivalent to dynamic_cast<Image*>(this).

Reimplemented in osg::BufferData, and osg::Image.

## asNode() [1/2]

virtual Node * osg::Object::asNode | ( |  | ) |

inline virtual

Convert 'this' into a Node pointer if Object is a Node, otherwise return 0. Equivalent to dynamic_cast<Node*>(this).

Reimplemented in osg::Node.

## asNode() [2/2]

virtual const Node * osg::Object::asNode | ( |  | ) | const

inline virtual

convert 'const this' into a const Node pointer if Object is a Node, otherwise return 0. Equivalent to dynamic_cast<const Node*>(this).

Reimplemented in osg::Node.

## asNodeVisitor() [1/2]

virtual NodeVisitor * osg::Object::asNodeVisitor | ( |  | ) |

inline virtual

Convert 'this' into a NodeVisitor pointer if Object is a NodeVisitor, otherwise return 0. Equivalent to dynamic_cast<NodeVisitor*>(this).

Referenced by osgGA::EventHandler::run().

## asNodeVisitor() [2/2]

virtual const NodeVisitor * osg::Object::asNodeVisitor | ( |  | ) | const

inline virtual

convert 'const this' into a const NodeVisitor pointer if Object is a NodeVisitor, otherwise return 0. Equivalent to dynamic_cast<const NodeVisitor*>(this).

Reimplemented in osg::NodeVisitor.

## asStateAttribute() [1/2]

virtual StateAttribute * osg::Object::asStateAttribute | ( |  | ) |

inline virtual

Convert 'this' into a StateAttribute pointer if Object is a StateAttribute, otherwise return 0. Equivalent to dynamic_cast<StateAttribute*>(this).

Reimplemented in osg::StateAttribute.

Referenced by osg::State::applyAttribute(), and osg::State::applyAttributeOnTexUnit().

## asStateAttribute() [2/2]

virtual const StateAttribute * osg::Object::asStateAttribute | ( |  | ) | const

inline virtual

convert 'const this' into a const StateAttribute pointer if Object is a StateAttribute, otherwise return 0. Equivalent to dynamic_cast<const StateAttribute*>(this).

Reimplemented in osg::StateAttribute.

## asStateSet() [1/2]

virtual StateSet * osg::Object::asStateSet | ( |  | ) |

inline virtual

Convert 'this' into a StateSet pointer if Object is a StateSet, otherwise return 0. Equivalent to dynamic_cast<StateSet*>(this).

Reimplemented in osg::StateSet.

## asStateSet() [2/2]

virtual const StateSet * osg::Object::asStateSet | ( |  | ) | const

inline virtual

convert 'const this' into a const StateSet pointer if Object is a StateSet, otherwise return 0. Equivalent to dynamic_cast<const StateSet*>(this).

Reimplemented in osg::StateSet.

## asUniform() [1/2]

virtual Uniform * osg::Object::asUniform | ( |  | ) |

inline virtual

Convert 'this' into a Uniform pointer if Object is a Uniform, otherwise return 0. Equivalent to dynamic_cast<Uniform*>(this).

Reimplemented in osg::Uniform.

## asUniform() [2/2]

virtual const Uniform * osg::Object::asUniform | ( |  | ) | const

inline virtual

convert 'const this' into a const Uniform pointer if Object is a Uniform, otherwise return 0. Equivalent to dynamic_cast<const Uniform*>(this).

Reimplemented in osg::Uniform.

## asUserDataContainer() [1/2]

virtual UserDataContainer * osg::Object::asUserDataContainer | ( |  | ) |

inline virtual

Convert 'this' into a UserDataContainer pointer if Object is a UserDataContainer, otherwise return 0. Equivalent to dynamic_cast<UserDataContainer*>(this).

Reimplemented in osg::UserDataContainer.

Referenced by getUserValue(), and setUserValue().

## asUserDataContainer() [2/2]

virtual const UserDataContainer * osg::Object::asUserDataContainer | ( |  | ) | const

inline virtual

convert 'const this' into a const UserDataContainer pointer if Object is a UserDataContainer, otherwise return 0. Equivalent to dynamic_cast<const UserDataContainer*>(this).

Reimplemented in osg::UserDataContainer.

## asValueObject() [1/2]

virtual ValueObject * osg::Object::asValueObject | ( |  | ) |

inline virtual

Convert 'this' into a ValueObject pointer if Object is a ValueObject, otherwise return 0. Equivalent to dynamic_cast<ValueObject*>(this).

## asValueObject() [2/2]

virtual const ValueObject * osg::Object::asValueObject | ( |  | ) | const

inline virtual

Convert 'this' into a ValueObject pointer if Object is a ValueObject, otherwise return 0. Equivalent to dynamic_cast<ValueObject*>(this).

Reimplemented in osg::ValueObject.

## className()

virtual const char * osg::Object::className | ( |  | ) | const

pure virtual

return the name of the object's class type. Must be defined by derived classes.

Implemented in osg::Array, osg::AudioSink, osg::AudioStream, osg::AutoTransform, osg::BufferData, osg::BufferObject, osg::BufferTemplate< T >, osg::BufferTemplate< std::vector< T > >, osg::ClipPlane, osg::DrawArrayLengths, osg::DrawArrays, osg::DrawArraysIndirect, osg::DrawElementsIndirectUByte, osg::DrawElementsIndirectUInt, osg::DrawElementsIndirectUShort, osg::DrawElementsUByte, osg::DrawElementsUInt, osg::DrawElementsUShort, osg::DrawPixels, osg::GraphicsContext, osg::Hint, osg::Image, osg::ImageSequence, osg::ImageStream, osg::Light, osg::MultiDrawArrays, osg::MultiDrawArraysIndirect, osg::MultiDrawElementsIndirectUByte, osg::MultiDrawElementsIndirectUInt, osg::MultiDrawElementsIndirectUShort, osg::Node, osg::PrimitiveSet, osg::RefMatrixd, osg::RefMatrixf, osg::ShaderAttribute, osg::Shape, osg::ShapeDrawable, osg::StateAttribute, osg::StateSet, osg::TemplateValueObject< T >, osg::Texture, osg::UserDataContainer, osg::VertexAttribDivisor, osgAnimation::Channel, osgAnimation::MorphGeometry, osgDB::Archive, osgFX::Effect, osgGA::AnimationPathManipulator, osgGA::CameraManipulator, osgGA::CameraViewSwitchManipulator, osgGA::DriveManipulator, osgGA::KeySwitchMatrixManipulator, osgGA::SphericalManipulator, osgGA::StandardManipulator, osgGA::StateSetManipulator, osgGA::UFOManipulator, osgManipulator::AntiSquish, osgParticle::CenteredPlacer, osgParticle::Counter, osgParticle::Emitter, osgParticle::Interpolator, osgParticle::Operator, osgParticle::ParticleEffect, osgParticle::ParticleProcessor, osgParticle::Placer, osgParticle::PrecipitationEffect, osgParticle::Program, osgParticle::Shooter, osgParticle::VariableRateCounter, osgShadow::ShadowTechnique, osgSim::ImpostorSprite, osgSim::Sector, osgText::Font, osgText::GlyphTexture, osgText::Text, osgText::TextBase, osgUtil::PositionalStateContainer, osgUtil::RenderBin, osgUtil::RenderStage, osgUtil::StateGraph, osgViewer::GraphicsWindow, osgViewer::GraphicsWindowEmbedded, osgViewer::GraphicsWindowWin32, osgViewer::GraphicsWindowX11, osgViewer::PixelBufferWin32, and osgViewer::PixelBufferX11.

Referenced by getCompoundClassName(), osgAnimation::UpdateUniform< T >::link(), and osgDB::ClassInterface::setProperty().

## clone()

virtual Object * osg::Object::clone | ( | const CopyOp & |  | ) | const

pure virtual

Clone an object, with Object* return type. Must be defined by derived classes.

Implemented in osg::AutoTransform, osg::BufferTemplate< T >, osg::BufferTemplate< std::vector< T > >, osg::ClipPlane, osg::DrawArrayLengths, osg::DrawArrays, osg::DrawArraysIndirect, osg::DrawElementsIndirectUByte, osg::DrawElementsIndirectUInt, osg::DrawElementsIndirectUShort, osg::DrawElementsUByte, osg::DrawElementsUInt, osg::DrawElementsUShort, osg::DrawPixels, osg::GraphicsContext, osg::Hint, osg::Image, osg::ImageSequence, osg::ImageStream, osg::Light, osg::MultiDrawArrays, osg::MultiDrawArraysIndirect, osg::MultiDrawElementsIndirectUByte, osg::MultiDrawElementsIndirectUInt, osg::MultiDrawElementsIndirectUShort, osg::Node, osg::RefMatrixd, osg::RefMatrixf, osg::ShaderAttribute, osg::Shape, osg::ShapeDrawable, osg::StateAttribute, osg::StateSet, osg::TemplateArray< T, ARRAYTYPE, DataSize, DataType >, osg::TemplateArray< GLdouble, Array::DoubleArrayType, 1, GL_DOUBLE >, osg::TemplateArray< GLfloat, Array::FloatArrayType, 1, GL_FLOAT >, osg::TemplateArray< Matrixd, Array::MatrixdArrayType, 16, GL_DOUBLE >, osg::TemplateArray< Matrixf, Array::MatrixArrayType, 16, GL_FLOAT >, osg::TemplateArray< Quat, Array::QuatArrayType, 4, GL_DOUBLE >, osg::TemplateArray< Vec2, Array::Vec2ArrayType, 2, GL_FLOAT >, osg::TemplateArray< Vec2b, Array::Vec2bArrayType, 2, GL_BYTE >, osg::TemplateArray< Vec2d, Array::Vec2dArrayType, 2, GL_DOUBLE >, osg::TemplateArray< Vec2i, Array::Vec2iArrayType, 2, GL_INT >, osg::TemplateArray< Vec2s, Array::Vec2sArrayType, 2, GL_SHORT >, osg::TemplateArray< Vec2ub, Array::Vec2ubArrayType, 2, GL_UNSIGNED_BYTE >, osg::TemplateArray< Vec2ui, Array::Vec2uiArrayType, 2, GL_UNSIGNED_INT >, osg::TemplateArray< Vec2us, Array::Vec2usArrayType, 2, GL_UNSIGNED_SHORT >, osg::TemplateArray< Vec3, Array::Vec3ArrayType, 3, GL_FLOAT >, osg::TemplateArray< Vec3b, Array::Vec3bArrayType, 3, GL_BYTE >, osg::TemplateArray< Vec3d, Array::Vec3dArrayType, 3, GL_DOUBLE >, osg::TemplateArray< Vec3i, Array::Vec3iArrayType, 3, GL_INT >, osg::TemplateArray< Vec3s, Array::Vec3sArrayType, 3, GL_SHORT >, osg::TemplateArray< Vec3ub, Array::Vec3ubArrayType, 3, GL_UNSIGNED_BYTE >, osg::TemplateArray< Vec3ui, Array::Vec3uiArrayType, 3, GL_UNSIGNED_INT >, osg::TemplateArray< Vec3us, Array::Vec3usArrayType, 3, GL_UNSIGNED_SHORT >, osg::TemplateArray< Vec4, Array::Vec4ArrayType, 4, GL_FLOAT >, osg::TemplateArray< Vec4b, Array::Vec4bArrayType, 4, GL_BYTE >, osg::TemplateArray< Vec4d, Array::Vec4dArrayType, 4, GL_DOUBLE >, osg::TemplateArray< Vec4i, Array::Vec4iArrayType, 4, GL_INT >, osg::TemplateArray< Vec4s, Array::Vec4sArrayType, 4, GL_SHORT >, osg::TemplateArray< Vec4ub, Array::Vec4ubArrayType, 4, GL_UNSIGNED_BYTE >, osg::TemplateArray< Vec4ui, Array::Vec4uiArrayType, 4, GL_UNSIGNED_INT >, osg::TemplateArray< Vec4us, Array::Vec4usArrayType, 4, GL_UNSIGNED_SHORT >, osg::TemplateIndexArray< T, ARRAYTYPE, DataSize, DataType >, osg::TemplateIndexArray< GLbyte, Array::ByteArrayType, 1, GL_BYTE >, osg::TemplateIndexArray< GLint, Array::IntArrayType, 1, GL_INT >, osg::TemplateIndexArray< GLint64, Array::Int64ArrayType, 1, GL_INT64_ARB >, osg::TemplateIndexArray< GLshort, Array::ShortArrayType, 1, GL_SHORT >, osg::TemplateIndexArray< GLubyte, Array::UByteArrayType, 1, GL_UNSIGNED_BYTE >, osg::TemplateIndexArray< GLuint, Array::UIntArrayType, 1, GL_UNSIGNED_INT >, osg::TemplateIndexArray< GLuint64, Array::UInt64ArrayType, 1, GL_UNSIGNED_INT64_ARB >, osg::TemplateIndexArray< GLushort, Array::UShortArrayType, 1, GL_UNSIGNED_SHORT >, osg::TemplateValueObject< T >, osg::Texture, osg::VertexAttribDivisor, osgAnimation::MorphGeometry, osgAnimation::TemplateChannel< SamplerType >, osgAnimation::TemplateChannel< DoubleCubicBezierSampler >, osgAnimation::TemplateChannel< DoubleLinearSampler >, osgAnimation::TemplateChannel< DoubleStepSampler >, osgAnimation::TemplateChannel< FloatCubicBezierSampler >, osgAnimation::TemplateChannel< FloatLinearSampler >, osgAnimation::TemplateChannel< FloatStepSampler >, osgAnimation::TemplateChannel< MatrixLinearSampler >, osgAnimation::TemplateChannel< QuatSphericalLinearSampler >, osgAnimation::TemplateChannel< QuatStepSampler >, osgAnimation::TemplateChannel< Vec2CubicBezierSampler >, osgAnimation::TemplateChannel< Vec2LinearSampler >, osgAnimation::TemplateChannel< Vec2StepSampler >, osgAnimation::TemplateChannel< Vec3CubicBezierSampler >, osgAnimation::TemplateChannel< Vec3LinearSampler >, osgAnimation::TemplateChannel< Vec3StepSampler >, osgAnimation::TemplateChannel< Vec4CubicBezierSampler >, osgAnimation::TemplateChannel< Vec4LinearSampler >, osgAnimation::TemplateChannel< Vec4StepSampler >, osgManipulator::AntiSquish, osgSim::ImpostorSprite, osgText::Font, osgText::Text, osgUtil::PositionalStateContainer, osgUtil::RenderBin, osgUtil::RenderStage, and osgUtil::StateGraph.

References Object().

Referenced by osgDB::Options::cloneOptions(), and osg::KdTreeBuilder::META_NodeVisitor().

## cloneType()

virtual Object * osg::Object::cloneType | ( |  | ) | const

pure virtual

Clone the type of an object, with Object* return type. Must be defined by derived classes.

Implemented in osg::AutoTransform, osg::BufferTemplate< T >, osg::BufferTemplate< std::vector< T > >, osg::ClipPlane, osg::DrawArrayLengths, osg::DrawArrays, osg::DrawArraysIndirect, osg::DrawElementsIndirectUByte, osg::DrawElementsIndirectUInt, osg::DrawElementsIndirectUShort, osg::DrawElementsUByte, osg::DrawElementsUInt, osg::DrawElementsUShort, osg::DrawPixels, osg::GraphicsContext, osg::Hint, osg::Image, osg::ImageSequence, osg::ImageStream, osg::Light, osg::MultiDrawArrays, osg::MultiDrawArraysIndirect, osg::MultiDrawElementsIndirectUByte, osg::MultiDrawElementsIndirectUInt, osg::MultiDrawElementsIndirectUShort, osg::Node, osg::RefMatrixd, osg::RefMatrixf, osg::ShaderAttribute, osg::Shape, osg::ShapeDrawable, osg::StateAttribute, osg::StateSet, osg::TemplateArray< T, ARRAYTYPE, DataSize, DataType >, osg::TemplateArray< GLdouble, Array::DoubleArrayType, 1, GL_DOUBLE >, osg::TemplateArray< GLfloat, Array::FloatArrayType, 1, GL_FLOAT >, osg::TemplateArray< Matrixd, Array::MatrixdArrayType, 16, GL_DOUBLE >, osg::TemplateArray< Matrixf, Array::MatrixArrayType, 16, GL_FLOAT >, osg::TemplateArray< Quat, Array::QuatArrayType, 4, GL_DOUBLE >, osg::TemplateArray< Vec2, Array::Vec2ArrayType, 2, GL_FLOAT >, osg::TemplateArray< Vec2b, Array::Vec2bArrayType, 2, GL_BYTE >, osg::TemplateArray< Vec2d, Array::Vec2dArrayType, 2, GL_DOUBLE >, osg::TemplateArray< Vec2i, Array::Vec2iArrayType, 2, GL_INT >, osg::TemplateArray< Vec2s, Array::Vec2sArrayType, 2, GL_SHORT >, osg::TemplateArray< Vec2ub, Array::Vec2ubArrayType, 2, GL_UNSIGNED_BYTE >, osg::TemplateArray< Vec2ui, Array::Vec2uiArrayType, 2, GL_UNSIGNED_INT >, osg::TemplateArray< Vec2us, Array::Vec2usArrayType, 2, GL_UNSIGNED_SHORT >, osg::TemplateArray< Vec3, Array::Vec3ArrayType, 3, GL_FLOAT >, osg::TemplateArray< Vec3b, Array::Vec3bArrayType, 3, GL_BYTE >, osg::TemplateArray< Vec3d, Array::Vec3dArrayType, 3, GL_DOUBLE >, osg::TemplateArray< Vec3i, Array::Vec3iArrayType, 3, GL_INT >, osg::TemplateArray< Vec3s, Array::Vec3sArrayType, 3, GL_SHORT >, osg::TemplateArray< Vec3ub, Array::Vec3ubArrayType, 3, GL_UNSIGNED_BYTE >, osg::TemplateArray< Vec3ui, Array::Vec3uiArrayType, 3, GL_UNSIGNED_INT >, osg::TemplateArray< Vec3us, Array::Vec3usArrayType, 3, GL_UNSIGNED_SHORT >, osg::TemplateArray< Vec4, Array::Vec4ArrayType, 4, GL_FLOAT >, osg::TemplateArray< Vec4b, Array::Vec4bArrayType, 4, GL_BYTE >, osg::TemplateArray< Vec4d, Array::Vec4dArrayType, 4, GL_DOUBLE >, osg::TemplateArray< Vec4i, Array::Vec4iArrayType, 4, GL_INT >, osg::TemplateArray< Vec4s, Array::Vec4sArrayType, 4, GL_SHORT >, osg::TemplateArray< Vec4ub, Array::Vec4ubArrayType, 4, GL_UNSIGNED_BYTE >, osg::TemplateArray< Vec4ui, Array::Vec4uiArrayType, 4, GL_UNSIGNED_INT >, osg::TemplateArray< Vec4us, Array::Vec4usArrayType, 4, GL_UNSIGNED_SHORT >, osg::TemplateIndexArray< T, ARRAYTYPE, DataSize, DataType >, osg::TemplateIndexArray< GLbyte, Array::ByteArrayType, 1, GL_BYTE >, osg::TemplateIndexArray< GLint, Array::IntArrayType, 1, GL_INT >, osg::TemplateIndexArray< GLint64, Array::Int64ArrayType, 1, GL_INT64_ARB >, osg::TemplateIndexArray< GLshort, Array::ShortArrayType, 1, GL_SHORT >, osg::TemplateIndexArray< GLubyte, Array::UByteArrayType, 1, GL_UNSIGNED_BYTE >, osg::TemplateIndexArray< GLuint, Array::UIntArrayType, 1, GL_UNSIGNED_INT >, osg::TemplateIndexArray< GLuint64, Array::UInt64ArrayType, 1, GL_UNSIGNED_INT64_ARB >, osg::TemplateIndexArray< GLushort, Array::UShortArrayType, 1, GL_UNSIGNED_SHORT >, osg::TemplateValueObject< T >, osg::Texture, osg::VertexAttribDivisor, osgAnimation::MorphGeometry, osgAnimation::TemplateChannel< SamplerType >, osgAnimation::TemplateChannel< DoubleCubicBezierSampler >, osgAnimation::TemplateChannel< DoubleLinearSampler >, osgAnimation::TemplateChannel< DoubleStepSampler >, osgAnimation::TemplateChannel< FloatCubicBezierSampler >, osgAnimation::TemplateChannel< FloatLinearSampler >, osgAnimation::TemplateChannel< FloatStepSampler >, osgAnimation::TemplateChannel< MatrixLinearSampler >, osgAnimation::TemplateChannel< QuatSphericalLinearSampler >, osgAnimation::TemplateChannel< QuatStepSampler >, osgAnimation::TemplateChannel< Vec2CubicBezierSampler >, osgAnimation::TemplateChannel< Vec2LinearSampler >, osgAnimation::TemplateChannel< Vec2StepSampler >, osgAnimation::TemplateChannel< Vec3CubicBezierSampler >, osgAnimation::TemplateChannel< Vec3LinearSampler >, osgAnimation::TemplateChannel< Vec3StepSampler >, osgAnimation::TemplateChannel< Vec4CubicBezierSampler >, osgAnimation::TemplateChannel< Vec4LinearSampler >, osgAnimation::TemplateChannel< Vec4StepSampler >, osgManipulator::AntiSquish, osgSim::ImpostorSprite, osgText::Font, osgText::Text, osgUtil::PositionalStateContainer, osgUtil::RenderBin, osgUtil::RenderStage, and osgUtil::StateGraph.

References Object().

Referenced by osg::CollectOccludersVisitor::META_NodeVisitor().

## computeDataVariance()

virtual void osg::Object::computeDataVariance | ( |  | ) |

inline virtual

Compute the DataVariance based on an assessment of callback etc.

Reimplemented in osg::Drawable, and osg::StateSet.

## getCompoundClassName()

std::string osg::Object::getCompoundClassName | ( |  | ) | const

inline

return the compound class name that combines the library name and class name.

References className(), and libraryName().

## getDataVariance()

DataVariance osg::Object::getDataVariance | ( |  | ) | const

inline

Get the data variance of this object.

References _dataVariance.

Referenced by osg::Drawable::draw(), osgUtil::RenderLeaf::RenderLeaf(), osgUtil::RenderLeaf::set(), and osgUtil::StateGraph::StateGraph().

## getName()

const std::string & osg::Object::getName | ( |  | ) | const

inline

Get the name of object.

References _name.

Referenced by osgTerrain::CompositeLayer::addLayer(), osg::State::applyShaderCompositionUniform(), osgTerrain::Layer::getCompoundName(), osgTerrain::Layer::getSetName(), osg::runNamedCallbackObjects(), and osgAnimation::UpdateRigGeometry::update().

## getOrCreateUserDataContainer()

osg::UserDataContainer * osg::Object::getOrCreateUserDataContainer | ( |  | ) |

Convenience method that returns the UserDataContainer, and if one doesn't already exist creates and assigns a DefaultUserDataContainer to the Object and then return this new UserDataContainer.

Referenced by osg::getOrCreateUserObjectOfType(), osgDB::ClassInterface::setProperty(), and setUserValue().

## getUserData() [1/2]

virtual Referenced * osg::Object::getUserData | ( |  | ) |

virtual

Get user data.

Reimplemented in osg::DefaultUserDataContainer, osg::UserDataContainer, and osgUtil::StateGraph.

References osg::Referenced::Referenced().

Referenced by osgUtil::Optimizer::isOperationPermissibleForObjectImplementation(), and osgUtil::Optimizer::isOperationPermissibleForObjectImplementation().

## getUserData() [2/2]

virtual const Referenced * osg::Object::getUserData | ( |  | ) | const

virtual

Get const user data.

Reimplemented in osg::DefaultUserDataContainer, osg::UserDataContainer, and osgUtil::StateGraph.

References osg::Referenced::Referenced().

## getUserDataContainer() [1/2]

osg::UserDataContainer * osg::Object::getUserDataContainer | ( |  | ) |

inline

get the UserDataContainer attached to this object.

References _userDataContainer.

Referenced by osg::getCallbackObject(), osg::getCallbackObject(), osgDB::ClassInterface::getProperty(), osg::getUserObject(), osg::getUserObject(), and osg::runNamedCallbackObjects().

## getUserDataContainer() [2/2]

const osg::UserDataContainer * osg::Object::getUserDataContainer | ( |  | ) | const

inline

get the const UserDataContainer attached to this object.

References _userDataContainer.

## getUserValue() [1/2]

template<typename T>

bool osg::Object::getUserValue | ( | const std::string & | name,
|  | T & | value ) const

Convenience method that casts the named UserObject to osg::TemplateValueObject<T> and gets the value. To use this template method you need to include the osg/ValueObject header.

References setUserValue().

Referenced by getUserValue(), and osgPresentation::PropertyManager::META_Object().

## getUserValue() [2/2]

template<typename T>

BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool osg::Object::getUserValue | ( | const std::string & | name,
|  | T & | value ) const

provide implementation of osg::Object::getUserValue(..) template

References _userDataContainer, asUserDataContainer(), osg::UserDataContainer::getUserObject(), getUserValue(), and Object().

## isSameKindAs()

virtual bool osg::Object::isSameKindAs | ( | const Object * |  | ) | const

inline virtual

Reimplemented in osg::Array, osg::AudioStream, osg::AutoTransform, osg::BufferData, osg::BufferObject, osg::BufferTemplate< T >, osg::BufferTemplate< std::vector< T > >, osg::ClipPlane, osg::DrawArrayLengths, osg::DrawArrays, osg::DrawArraysIndirect, osg::DrawElementsIndirectUByte, osg::DrawElementsIndirectUInt, osg::DrawElementsIndirectUShort, osg::DrawElementsUByte, osg::DrawElementsUInt, osg::DrawElementsUShort, osg::DrawPixels, osg::GraphicsContext, osg::Hint, osg::Image, osg::ImageSequence, osg::ImageStream, osg::IndexArray, osg::Light, osg::MultiDrawArrays, osg::MultiDrawArraysIndirect, osg::MultiDrawElementsIndirectUByte, osg::MultiDrawElementsIndirectUInt, osg::MultiDrawElementsIndirectUShort, osg::Node, osg::PrimitiveSet, osg::RefMatrixd, osg::RefMatrixf, osg::ShaderAttribute, osg::Shape, osg::ShapeDrawable, osg::StateAttribute, osg::StateSet, osg::TemplateValueObject< T >, osg::Texture, osg::UserDataContainer, osg::VertexAttribDivisor, osgAnimation::MorphGeometry, osgFX::Effect, osgManipulator::AntiSquish, osgParticle::CenteredPlacer, osgParticle::Counter, osgParticle::Emitter, osgParticle::Interpolator, osgParticle::Operator, osgParticle::ParticleEffect, osgParticle::ParticleProcessor, osgParticle::Placer, osgParticle::PrecipitationEffect, osgParticle::Program, osgParticle::Shooter, osgParticle::VariableRateCounter, osgShadow::ShadowTechnique, osgSim::ImpostorSprite, osgSim::Sector, osgText::Font, osgText::Text, osgText::TextBase, osgUtil::PositionalStateContainer, osgUtil::RenderBin, osgUtil::RenderStage, and osgUtil::StateGraph.

References Object().

## libraryName()

virtual const char * osg::Object::libraryName | ( |  | ) | const

pure virtual

return the name of the object's library. Must be defined by derived classes. The OpenSceneGraph convention is that the namespace of a library is the same as the library name.

Implemented in osg::Array, osg::AudioSink, osg::AudioStream, osg::AutoTransform, osg::BufferData, osg::BufferObject, osg::BufferTemplate< T >, osg::BufferTemplate< std::vector< T > >, osg::ClipPlane, osg::DrawArrayLengths, osg::DrawArrays, osg::DrawArraysIndirect, osg::DrawElementsIndirectUByte, osg::DrawElementsIndirectUInt, osg::DrawElementsIndirectUShort, osg::DrawElementsUByte, osg::DrawElementsUInt, osg::DrawElementsUShort, osg::DrawPixels, osg::GraphicsContext, osg::Hint, osg::Image, osg::ImageSequence, osg::ImageStream, osg::Light, osg::MultiDrawArrays, osg::Node, osg::PrimitiveSet, osg::RefMatrixd, osg::RefMatrixf, osg::ShaderAttribute, osg::Shape, osg::ShapeDrawable, osg::StateAttribute, osg::StateSet, osg::TemplateValueObject< T >, osg::Texture, osg::UserDataContainer, osg::VertexAttribDivisor, osgAnimation::Channel, osgAnimation::MorphGeometry, osgDB::Archive, osgFX::Effect, osgManipulator::AntiSquish, osgParticle::CenteredPlacer, osgParticle::Counter, osgParticle::Emitter, osgParticle::Interpolator, osgParticle::Operator, osgParticle::ParticleEffect, osgParticle::ParticleProcessor, osgParticle::Placer, osgParticle::PrecipitationEffect, osgParticle::Program, osgParticle::Shooter, osgParticle::VariableRateCounter, osgShadow::ShadowTechnique, osgSim::ImpostorSprite, osgSim::Sector, osgText::Font, osgText::Text, osgText::TextBase, osgUtil::PositionalStateContainer, osgUtil::RenderBin, osgUtil::StateGraph, osgViewer::GraphicsWindow, osgViewer::GraphicsWindowEmbedded, osgViewer::GraphicsWindowWin32, osgViewer::GraphicsWindowX11, osgViewer::PixelBufferWin32, and osgViewer::PixelBufferX11.

Referenced by getCompoundClassName().

## releaseGLObjects()

virtual void osg::Object::releaseGLObjects | ( | osg::State * | = 0 | ) | const

inline virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented in osg::BufferData, osg::BufferObject, osg::Camera::DrawCallback, osg::Camera, osg::Drawable, osg::FragmentProgram, osg::FrameBufferObject, osg::Geometry, osg::Group, osg::Node, osg::OcclusionQueryNode, osg::Program, osg::QueryGeometry, osg::RenderBuffer, osg::Sampler, osg::Shader, osg::ShaderAttribute, osg::ShaderComponent, osg::ShaderComposer, osg::StateAttribute, osg::StateSet, osg::Texture, osg::VertexProgram, osg::View, osgDB::SharedStateManager, osgFX::Effect, osgParticle::ParticleSystem, osgParticle::PrecipitationEffect::PrecipitationDrawable, osgParticle::PrecipitationEffect, osgShadow::DebugShadowMap, osgShadow::ParallelSplitShadowMap, osgShadow::ShadowedScene, osgShadow::ShadowMap, osgShadow::ShadowTechnique, osgShadow::ShadowTexture, osgShadow::StandardShadowMap, osgShadow::ViewDependentShadowMap, osgShadow::ViewDependentShadowTechnique, osgSim::OverlayNode, osgSim::SphereSegment, osgTerrain::DisplacementMappingTechnique, osgTerrain::GeometryTechnique, osgTerrain::HeightFieldDrawable, osgTerrain::SharedGeometry, osgTerrain::TerrainTechnique, osgTerrain::TerrainTile, osgText::Font, osgText::Text3D, osgText::Text, osgText::TextBase, osgUI::Widget, osgUtil::RenderBin, osgUtil::RenderStage, osgUtil::SceneView, osgUtil::StateGraph, and osgViewer::Viewer.

## resizeGLObjectBuffers()

virtual void osg::Object::resizeGLObjectBuffers | ( | unsigned int |  | ) |

inline virtual

Resize any per context GLObject buffers to specified size.

Reimplemented in osg::BufferData, osg::BufferObject, osg::Camera::DrawCallback, osg::Camera, osg::Drawable, osg::FragmentProgram, osg::FrameBufferObject, osg::Geometry, osg::Group, osg::Node, osg::PixelDataBufferObject, osg::Program, osg::RenderBuffer, osg::Shader, osg::ShaderAttribute, osg::ShaderComponent, osg::StateAttribute, osg::StateSet, osg::Texture, osg::VertexProgram, osg::View, osgFX::Effect, osgParticle::ParticleSystem, osgParticle::PrecipitationEffect::PrecipitationDrawable, osgParticle::PrecipitationEffect, osgShadow::DebugShadowMap, osgShadow::ParallelSplitShadowMap, osgShadow::ShadowedScene, osgShadow::ShadowMap, osgShadow::ShadowTechnique, osgShadow::ShadowTexture, osgShadow::StandardShadowMap, osgShadow::ViewDependentShadowMap, osgShadow::ViewDependentShadowTechnique, osgSim::OverlayNode, osgSim::SphereSegment, osgTerrain::HeightFieldDrawable, osgTerrain::SharedGeometry, osgText::Font, osgText::GlyphTexture, osgText::Text3D, osgText::Text, osgText::TextBase, osgUI::Widget, osgUtil::SceneView, osgUtil::StateGraph, and osgViewer::Viewer.

## setDataVariance()

void osg::Object::setDataVariance | ( | DataVariance | dv | ) |

inline

Set the data variance of this object. Can be set to either STATIC for values that do not change over the lifetime of the object, or DYNAMIC for values that vary over the lifetime of the object. The DataVariance value can be used by routines such as optimization codes that wish to share static data. UNSPECIFIED is used to specify that the DataVariance hasn't been set yet.

References _dataVariance.

## setName() [1/2]

void osg::Object::setName | ( | const char * | name | ) |

inline

Set the name of object using a C style string.

References setName().

## setName() [2/2]

virtual void osg::Object::setName | ( | const std::string & | name | ) |

inline virtual

Set the name of object using C++ style string.

Reimplemented in osg::Uniform, and osgAnimation::Channel.

References _name.

Referenced by osg::CallbackObject::CallbackObject(), osg::ScriptEngine::ScriptEngine(), setName(), osgDB::ClassInterface::setProperty(), osgTerrain::Layer::setSetName(), and osg::ValueObject::ValueObject().

## setThreadSafeRefUnref()

virtual void osg::Object::setThreadSafeRefUnref | ( | bool | threadSafe | ) |

virtual

Set whether to use a mutex to ensure ref() and unref() are thread safe.

Reimplemented from osg::Referenced.

Reimplemented in osg::Drawable, osg::Group, osg::LightSource, osg::Node, osg::Program, osg::StateSet, osg::TexGenNode, osgSim::OverlayNode, osgText::Font, and osgText::GlyphTexture.

Referenced by osg::DefaultUserDataContainer::META_Object().

## setUserData() [1/2]

template<class T>

void osg::Object::setUserData | ( | const ref_ptr< T > & | ud | ) |

inline

References osg::ref_ptr< T >::get(), and setUserData().

Referenced by setUserData().

## setUserData() [2/2]

virtual void osg::Object::setUserData | ( | Referenced * | obj | ) |

virtual

Set user data, data must be subclassed from Referenced to allow automatic memory handling. If your own data isn't directly subclassed from Referenced then create an adapter object which points to your own object and handles the memory addressing.

Reimplemented in osg::DefaultUserDataContainer, osg::UserDataContainer, and osgUtil::StateGraph.

References osg::Referenced::Referenced().

Referenced by osg::DefaultUserDataContainer::setUserData(), and osg::UserDataContainer::setUserData().

## setUserDataContainer() [1/2]

template<class T>

void osg::Object::setUserDataContainer | ( | const ref_ptr< T > & | udc | ) |

inline

References osg::ref_ptr< T >::get(), and setUserDataContainer().

Referenced by setUserDataContainer().

## setUserDataContainer() [2/2]

void osg::Object::setUserDataContainer | ( | osg::UserDataContainer * | udc | ) |

set the UserDataContainer object.

## setUserValue()

template<typename T>

void osg::Object::setUserValue | ( | const std::string & | name,
|  | const T & | value )

Convenience method that creates the osg::TemplateValueObject<T> to store the specified value and adds it as a named UserObject. To use this template method you need to include the osg/ValueObject header.

provide implementation of osg::Object::setUserValue(..) template.

References _userDataContainer, osg::UserDataContainer::addUserObject(), asUserDataContainer(), getOrCreateUserDataContainer(), osg::UserDataContainer::getUserObject(), osg::UserDataContainer::getUserObjectIndex(), Object(), and osg::UserDataContainer::setUserObject().

Referenced by getUserValue().

## Member Data Documentation

## _dataVariance

DataVariance osg::Object::_dataVariance

protected

Referenced by getDataVariance(), Object(), Object(), and setDataVariance().

## _name

std::string osg::Object::_name

protected

Referenced by osgWidget::Frame::createSimpleFrame(), osgWidget::Frame::createSimpleFrameWithSingleTexture(), osgWidget::NotifyWidget::focus(), getName(), osgWidget::NotifyWidget::keyPress(), osgWidget::NotifyWidget::keyRelease(), osgWidget::NotifyWidget::mouseDrag(), osgWidget::NotifyWidget::mouseEnter(), osgWidget::NotifyWidget::mouseLeave(), osgWidget::NotifyWidget::mouseOver(), osgWidget::NotifyWidget::mousePush(), osgWidget::NotifyWidget::mouseRelease(), osgWidget::NotifyWidget::mouseScroll(), osgWidget::Frame::Border::setBorderTypeAndName(), osgWidget::Frame::Corner::setCornerTypeAndName(), setName(), and osgWidget::NotifyWidget::unfocus().

## _userDataContainer

osg::UserDataContainer* osg::Object::_userDataContainer

protected

Referenced by getUserDataContainer(), getUserDataContainer(), getUserValue(), Object(), Object(), and setUserValue().

The documentation for this class was generated from the following files:

- Object
- ValueObject